program queens;

uses timer {$IFDEF VIRTUALPASCAL} , use32 {$ENDIF};

Const Nmax=63;

{$IFDEF __GPC__}
type longint=integer;
{$ENDIF}
{$IFDEF FPK}
type integer=longint;
{$ENDIF}

var
  Num     : longint;
  NC, Cod : integer;
  v       : array [0..Nmax] of byte;
  h       : array [0..Nmax] of boolean;
  d1      : array [0..2*Nmax] of boolean;
  d2      : array [-Nmax..Nmax] of boolean;

procedure Find(N:integer);

Label M1;

var
   x, y : integer;

begin
  Num:=0; x:=1;
M1:
  y:=N;
  repeat
    while y > 0 do begin
      if h[y] and d1[x+y] and d2[x-y] then begin
        v[x]:=y;         {H㯠 }
        if x=N then begin
        {  ⠢}
          inc(Num)
        end else begin
          h[y]:=false;     {頥   ਧ⠫}
          d1[x+y]:=false; d2[x-y]:=false;
          inc(x);
          GoTo M1;
        end;
      end;
      dec(y);
    end;
    dec(x);
    if x=0 then break;
    y:=v[x];
    h[y]:=true;              {⪠}
    d1[x+y]:=true; d2[x-y]:=true;
    dec(y);
  until false;
end;

procedure Help;

begin
  writeln; writeln('Usage: Queens N [2..63]'); halt
end;

begin
  for NC:=1 to Nmax do h[NC]:=true;
  for NC:=2 to 2*Nmax do D1[NC]:=true;
  for NC:=-Nmax+1 to Nmax-1 do D2[NC]:=true;

  if ParamCount <> 1 then Help;
  Val(ParamStr(1),NC,Cod);
  if Cod<>0 then Help;
  if (NC<2) or (NC>63) then Help;
  time1;
  Find(NC);
  writeln(Num,' ਠ⮢', time2*1e-3:7:2,' Sec');
end.

